from math import floor
from resources.lib.const import PLAYER_SERVICE_EVENT
from resources.lib.kodilogging import service_logger
from resources.lib.players import BasePlayer


class StreamCinemaPlayer(BasePlayer):
    def __init__(self, service, player_core=0):
        super(StreamCinemaPlayer, self).__init__(service, player_core)
        self._service = service

    def getProgressRatio(self):
        if self.isPlayingVideo():
            return floor(self.getTime()/self.getTotalTime()*100)

    def onAVStarted(self):
        service_logger.debug("onAVStarted")

    def onPlayBackStarted(self):
        service_logger.debug("Playback started")
        progress = self.getProgressRatio()
        if progress:
            self._service.scrobble_play()

    def onPlayBackPaused(self):
        progress = self.getProgressRatio()
        if progress:
            self._service.scrobble_pause(progress)

    def onPlayBackResumed(self):
        progress = self.getProgressRatio()
        if progress:
            self._service.scrobble_start(progress)

    def onPlayBackEnded(self):
        service_logger.debug("onPlayBackEnded")

    def onPlayBackStopped(self):
        service_logger.debug("onPlaybackStopped")
        progress = self.getProgressRatio()
        if progress:
            self._service.scrobble_stop(progress)
